
// policy service (called by refilterNode) -- global-var.
var policy = Components.classes["@mozilla.org/layout/content-policy;1"].getService(Components.interfaces.nsIContentPolicy);
var appShell = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);
var hiddenWnd = appShell.hiddenDOMWindow; // global hidden-window
var apiConstants = hiddenWnd.apiConstants;

// user clicked "OK", so save the pattern and 'live-filter' the target item
function doOK() {

    var URI = Components.classes["@mozilla.org/network/simple-uri;1"].createInstance(Components.interfaces.nsIURI);
    var textbox = document.getElementById("tbox");
    var enableRevert = window.arguments[0];
    var autoSyncElem = window.arguments[1];
	var Sync = window.arguments[2];
	
	//Load locale string bundle
	var gAdBlockBundle = document.getElementById("bundle_adblock");

	//Load file to check path and file is ok
	if (textbox.value != "") {
        
        var IOService 	= Components.classes["@mozilla.org/network/io-service;1"].createInstance(Components.interfaces.nsIIOService);
        
        //Workaround for Deer Park Alpha, if syncPath is a folder Deer Park crashes.
        try
        {
            // file is nsIFile
            var fileHandler = IOService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
            var file = fileHandler.getFileFromURLSpec(textbox.value);
            var localPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            
            localPath.initWithPath(file.path);
            
            if (localPath.isDirectory())
            {
                alert(gAdBlockBundle.getString("adblock.invalidfileorpath"));
                return false;
            }
            
        } 
        catch (e) {}
        
		try
        {
			var channel = IOService.newChannel(textbox.value, null, null);
			var stream 	= channel.open(); // This should be changed to async mode instead of sync if it doesn't work
			var streamIO 	= Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			var input = "", inputArray, linebreak;
			
            streamIO.init(stream);
            
            if (channel.contentLength > 0)
                length = channel.contentLength;
            else
                length = stream.available();
            
            while (input.length < length)
                input += streamIO.read(length - input.length);
        
            streamIO.close();
            stream.close();
			
			linebreak = input.match(/(?:\[Ad[Bb]lock\])(((\n+)|(\r+))+)/m)[1]; // first: whole match -- second: backref-1 -- etc..
			inputArray = input.split(linebreak);
			
			var headerRe = /\[Adblock\]/i; // tests if the first line is adblock's header
			if (headerRe.test(inputArray[0]) == false)
            {
				alert(gAdBlockBundle.getString("adblock.invalidfile"));
				return false;
			}
		} 
        catch(e)
        {
            alert(gAdBlockBundle.getString("adblock.invalidfileorpath"));
            return false;
        }
	}
    
    
	//It is possible someone could enable the autosync feature and seeing it does nothing leave it alone. Then later add the 
    //sync path and then loose their filters not knowing why. This will disable autosync to stop that from happening.
	//Won't prevent people from setting autosync before entering path while the dialog is still open.
    var autoSync = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("adblock.autosync");
    
    if ((Sync.path == null || Sync.path == "") && autoSync) {
        autoSyncElem.setAttribute("checked", false);
    }
	
	//Save entered path.
    try {        
		Sync.path = textbox.value;
        observerService.notifyObservers(null, "Adblock-SavePrefFile", null);    
    } catch(e) {}

    enableRevert();
	return true;
}

// user clicked "Cancel", so close out
function doCancel() {  	
	return true;
}

// set the input-field to the target item's source
function init() {

	var textelement = document.getElementById("tbox");
	var Sync = window.arguments[2];
	
	if (Sync.path != null)
		textelement.setAttribute("value", Sync.path);
}
