
// policy service (called by refilterNode) -- global-var.
var policy = Components.classes["@mozilla.org/layout/content-policy;1"].getService(Components.interfaces.nsIContentPolicy);
var appShell = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);
var hiddenWnd = appShell.hiddenDOMWindow; // global hidden-window
var apiConstants = hiddenWnd.apiConstants;


function adblockWarnAutoSync() {

    var Branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("adblock.");
	var autosync = document.getElementById("autosync");
    var warn = Branch.getBoolPref("autowarn");
	var menu = document.getElementById("options-menu");
    
	menu.hidePopup();
	
	if (!autosync.getAttribute("checked"))
    {
		enableRevert();
        return true; 
    }
        
	if (warn)
    {
		window.openDialog("chrome://adblock/content/warnautosyncdialog.xul","Warn auto synchronization","chrome,modal,centerscreen", adblockWarnResult);
		if (__abWarn) {
			Branch.setBoolPref("autowarn", false);
		}
		if (__abCancelled) {
            autosync.setAttribute("checked", false);
			return false;
		}
	}
	
    enableRevert();
	syncNow();
	return true;
}

// Synchronize now to show user what will happen. (They can then use revert to undo, now knowing what will happen).
function syncNow()
{
	try	{
        
        var URI = Components.classes["@mozilla.org/network/simple-uri;1"].createInstance(Components.interfaces.nsIURI);
        URI.spec = Sync.path;
        
        var IOService 	= Components.classes["@mozilla.org/network/io-service;1"].createInstance(Components.interfaces.nsIIOService);
        var channel = IOService.newChannel(Sync.path, null, null);
        var stream 	= channel.open(); // This should be changed to async mode instead of sync if it doesn't work
        var streamIO 	= Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        var input, inputArray, linebreak, inputLine = "";
        
        streamIO.init(stream);
        
        if (channel.contentLength > 0)
            length = channel.contentLength;
        else
            length = stream.available();
            
        while (input.length < length)
            input += streamIO.read(length - input.length);
        
        streamIO.close();
        stream.close();
        
        linebreak = input.match(/(?:\[Ad[Bb]lock\])(((\n+)|(\r+))+)/m)[1]; // first: whole match -- second: backref-1 -- etc..
        inputArray = input.split(linebreak);
        
        var headerRe = /\[Ad[Bb]lock\]/; // tests if the first line is adblock's header
        if (headerRe.test(inputArray[0])) {
            inputArray.shift();
            fillList(inputArray, true);
        }
        
    } 
    catch(e) {}
}


function returnResult(cancelled) {
	var checkbox = document.getElementById("autowarn");
	var warn = checkbox.checked;	
	window.arguments[0](cancelled, warn);
	return true;
}

function adblockWarnResult(cancelled, warnagain) {
	__abCancelled = cancelled;
	__abWarn = warnagain;
}
